# -*- coding: utf-8 -*-
'''
Created on 2010/10/07
 SHsSL RMD, RM, REN command.
@author: toru kageyama <info@comona.co.jp>
'''
#imports.
from settings import PARAM_0, PARAM_1

# RMD command.
def rmd(ftp, form, formatter):
    """RMD command."""
    ftp.cwd(form[PARAM_0].value)
    recursive_delete(ftp)
    ftp.cwd('..')
    ret = ftp.rmd(form[PARAM_0].value)
    # set result.
    if ret != None and len(ret) > 0 and ret[0] == '2':
        formatter.set_command_result(True)

# MKD command.
def mkd(ftp, form, formatter):
    """MKD command."""
    ret = ftp.mkd(form[PARAM_0].value)
    # set result.
    formatter.set_command_result(True)

# recursive delete.
def recursive_delete(ftp):
    """recursive delete."""
    local_list = []
    try:
        local_list = ftp.nlst()
        if local_list == None or len(local_list) < 1:
            # no list
            return
    except:
        # no list.
        pass

    for loc_path in local_list:
        if len(loc_path) > 0:
            try:
                # directory
                ftp.cwd(loc_path)
                recursive_delete(ftp)
                ftp.cwd('..')
                ftp.rmd(loc_path)
            except:
                # file.
                ftp.delete(loc_path)

# delete file.
def delete_file(ftp, form, formatter):
    """delete file."""
    ftp.delete(form[PARAM_0].value)
    # set result.
    formatter.set_command_result(True)

# rename file.
def rename_file(ftp, form, formatter):
    """rename file."""
    ftp.rename(form[PARAM_0].value, form[PARAM_1].value)
    # set result.
    formatter.set_command_result(True)
